//+------------------------------------------------------------------+
//|                                                       BB_PRC.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
#property indicator_buffers 4 
#property indicator_color1 Red
#property indicator_color2 Gold
#property indicator_color3 Aqua
#property indicator_color4 White



datetime prevtime;
double bol[];
double ma[];
double UpArrow[];
double DnArrow[];

extern bool   SendAnEmail=false; // Send E-Mail
extern bool   CepUyariGonder=true; // Send Cell Phone Notificatiom
extern bool   SMSGonder=true;// Send Cell Phone SMS
extern bool   SesliAlarm=true; // Sound Alert

extern int bPer=20,bDev=2,maPer=50,maMeth=MODE_EMA;
extern bool useAlerts=true;
extern int alertBar=1;
extern int alertSleep=1800;//in seconds
int lastAlert;
#property indicator_separate_window

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,bol);
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexEmptyValue(0,0.0);
   
   SetIndexBuffer(1,ma);
   SetIndexStyle(1,DRAW_LINE,EMPTY,1);
   SetIndexEmptyValue(1,0.0);
   

      SetIndexStyle(2,DRAW_ARROW);
      SetIndexArrow(2, 233);
      
      SetIndexStyle(3,DRAW_ARROW);
      SetIndexArrow(3, 234);
      
      SetIndexBuffer(2, UpArrow);
      SetIndexBuffer(3, DnArrow);
      
   IndicatorShortName("BB PRC RANGE v1");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  
   
  
  
   int i,counted_bars = prev_calculated;
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit=fmin(rates_total-counted_bars,rates_total-1); 
          for(int j=0; j<=limit;j++)
     {
      ma[j]=iMAOnArray(bol,0,maPer,0,maMeth,j);
     }
  for(i=limit;i>=0;i--)  
     {
      double bandL=iBands(Symbol(),0,bPer,bDev,0,PRICE_CLOSE,MODE_MINUSDI,i);
      double bandH=iBands(Symbol(),0,bPer,bDev,0,PRICE_CLOSE,MODE_PLUSDI,i);
     if((bandH-bandL)>0) bol[i]=((Close[i]-bandL)/(bandH-bandL));
     
        if(ma[i]>bol[i] &&  ma[i+1]<bol[i+1])
        {
         UpArrow[i]= bol[i]-10*Point;
         //Print("Burda BUY",bol[i]);
          }
          
          if(ma[i]<bol[i] &&  ma[i+1]>bol[i+1])
        {
        
          DnArrow[i]= bol[i]+10*Point;
        //Print("Burda SELL",bol[i]);
         }
      //if((Close[i]-bandL)==0 || (bandH-bandL)==0)
        // Print(i," ",(Close[i]-bandL)," ",(bandH-bandL));
        
     }


   if(iTime(Symbol(),60,0) == prevtime)
      return(0);
   prevtime = iTime(Symbol(),60,0);
  
     if(UpArrow[1]!=2147483647 && UpArrow[1]>0)
     {
      if(NewBar())
        {
         if(SesliAlarm)
            Alert(Symbol()+" TF:"+string(Period())+" BB_PRC-1 Correct BUY!.");
         if(CepUyariGonder)
            SendNotification("Haskaya  "+Symbol()+" TF:"+IntegerToString(Period())+ " BB_PRC-1 CorrectBUY!.") ;
         
        }

     }
   
    if(DnArrow[1]!=2147483647 && DnArrow[1]>0)
{
      if(NewBar())
        {
         if(SesliAlarm)
            Alert(Symbol()+" TF:"+string(Period())+" BB_PRC-1 Correct SELL!.");
         if(CepUyariGonder)
            SendNotification("Haskaya  "+Symbol()+" TF:"+IntegerToString(Period())+ " BB_PRC-1 Correct  SELL!.") ;
         
        }

     }

  
  /// BUY SELL Arrow
 
  /* 
   if(useAlerts)
     {
      if(ma[alertBar]>=bol[alertBar] && CurTime()>lastAlert && (bol[2+alertBar]>=bol[1+alertBar]) && (bol[1+alertBar] < bol[alertBar]))
        {
         Alert("BB PRC MADE LOW "+ Symbol() + " on the " +  Period() + " minute chart.");
         lastAlert=CurTime()+alertSleep;
        }

      if(ma[alertBar]<=bol[alertBar] && CurTime()>lastAlert && (bol[2+alertBar]<=bol[1+alertBar]) && (bol[1+alertBar] > bol[alertBar]))
        {
         Alert("BB PRC MADE HIGH "+ Symbol() + " on the " +  Period() + " minute chart.");
         lastAlert=CurTime()+alertSleep;
        }
*/
     


   return(0);
  }
  
  bool NewBar()
  {
   static datetime lastbar;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
     {
      lastbar=curbar;
      return (true);
     }
   else
     {
      return(false);
     }
  }
//+------------------------------------------------------------------+